"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const app_service_1 = require("./app.service");
let AppController = class AppController {
    constructor(service) {
        this.service = service;
    }
    header() {
        return this.service.header();
    }
    ;
    async getALLMovies(res, page) {
        const movies = await this.service.getALLMovies(page);
        return res.status(common_1.HttpStatus.OK).json({ movies: movies[0] });
    }
    ;
    async getLatestReleasesMovies(res, page) {
        const movies = await this.service.getLatestReleasesMoviesList(page);
        return res.status(common_1.HttpStatus.OK).json({ movies: movies[0] });
    }
    ;
    async getPopularMovies(res, page) {
        const movies = await this.service.getPopularMoviesList(page);
        return res.status(common_1.HttpStatus.OK).json({ movies: movies[0] });
    }
    ;
    async moviesByGenres(res, genre, page) {
        const genres = await this.service.getMovieByGenresList(genre, page);
        return res.status(common_1.HttpStatus.OK).json({ genres: genres[0] });
    }
    ;
    async getMovieServers(res, id) {
        const servers = await this.service.getMovieServerList(id);
        return res.status(common_1.HttpStatus.OK).json({ servers: servers });
    }
    ;
    async getAllSeries(res, page) {
        const series = await this.service.getALLSeries(page);
        return res.status(common_1.HttpStatus.OK).json({ series: series[0] });
    }
    ;
    async getSeriesServersBySeason(res, id, season) {
        const servers = await this.service.getALLServersBySeason(id, Number(season));
        return res.status(common_1.HttpStatus.OK).json({ servers: servers });
    }
    ;
    async getLatestReleasesSeries(res, page) {
        const series = await this.service.getLatestReleasesSeriesList(page);
        return res.status(common_1.HttpStatus.OK).json({ series: series[0] });
    }
    ;
    async getPopularSeries(res, page) {
        const series = await this.service.getPopularSeriesList(page);
        return res.status(common_1.HttpStatus.OK).json({ series: series[0] });
    }
    ;
    async seriesByGenres(res, genre, page) {
        const genres = await this.service.getSeriesByGenresList(genre, page);
        return res.status(common_1.HttpStatus.OK).json({ genres: genres[0] });
    }
    ;
    async search(res, query) {
        const content = await this.service.searchContent(query);
        return res.status(common_1.HttpStatus.OK).json({ search: content[0] });
    }
    ;
};
__decorate([
    common_1.Get('/'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Object)
], AppController.prototype, "header", null);
__decorate([
    common_1.Get('/GetAllMovies/:page'),
    __param(0, common_1.Res()), __param(1, common_1.Param('page')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getALLMovies", null);
__decorate([
    common_1.Get('/GetLatestMovies/:page'),
    __param(0, common_1.Res()), __param(1, common_1.Param('page')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getLatestReleasesMovies", null);
__decorate([
    common_1.Get('/GetPopularMovies/:page'),
    __param(0, common_1.Res()), __param(1, common_1.Param('page')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getPopularMovies", null);
__decorate([
    common_1.Get('/MoviesByGenre/:genre/:page'),
    __param(0, common_1.Res()), __param(1, common_1.Param('genre')), __param(2, common_1.Param('page')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "moviesByGenres", null);
__decorate([
    common_1.Get('/GetMovieServers/:id([^/]+/[^/]+)'),
    __param(0, common_1.Res()), __param(1, common_1.Param('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getMovieServers", null);
__decorate([
    common_1.Get('/GetAllSeries/:page'),
    __param(0, common_1.Res()), __param(1, common_1.Param('page')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getAllSeries", null);
__decorate([
    common_1.Get('/GetAllServersBySeason/:id([^/]+/[^/]+)/:season'),
    __param(0, common_1.Res()), __param(1, common_1.Param('id')), __param(2, common_1.Param('season')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getSeriesServersBySeason", null);
__decorate([
    common_1.Get('/GetLatestSeries/:page'),
    __param(0, common_1.Res()), __param(1, common_1.Param('page')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getLatestReleasesSeries", null);
__decorate([
    common_1.Get('/GetPopularSeries/:page'),
    __param(0, common_1.Res()), __param(1, common_1.Param('page')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "getPopularSeries", null);
__decorate([
    common_1.Get('/SeriesByGenre/:genre/:page'),
    __param(0, common_1.Res()), __param(1, common_1.Param('genre')), __param(2, common_1.Param('page')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String, Number]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "seriesByGenres", null);
__decorate([
    common_1.Get('/Search/:query'),
    __param(0, common_1.Res()), __param(1, common_1.Param('query')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", Promise)
], AppController.prototype, "search", null);
AppController = __decorate([
    common_1.Controller(),
    __metadata("design:paramtypes", [app_service_1.AppService])
], AppController);
exports.AppController = AppController;
//# sourceMappingURL=app.controller.js.map